$regfile = "M8def.dat"
$crystal = 8000000
$baud = 38400
$hwstack = 64
$swstack = 64
$framesize = 64

$lib "i2c_twi.lbx"

Dim Leds(12) As Word

Config Scl = Portc.5
Config Sda = Portc.4
Config Twi = 100000
I2cinit

Const Nunchuck_write = &HA4
Const Nunchuck_read = &HA5

Dim Buffer(16) As Byte
Dim Joy_x As Byte
Dim Joy_y As Byte
Dim Accel_x As Integer
Dim Accel_y As Integer
Dim Accel_z As Integer
Dim Buttons As Byte
Dim But_c As Byte
Dim But_z As Byte



Config Portc = 15
Config Portb = Output
Config Portd = 255
Config Timer2 = Timer , Prescale = 8
On Ovf2 Tim2_isr
Enable Timer2
Enable Interrupts
Start Timer2


Waitms 250
Print "Nunchack Init"
    I2cstart
    I2cwbyte Nunchuck_write
    I2cwbyte &H40
    If Err <> 0 Then
      Print "Error data sending"
    End If
    I2cwbyte &H00
    If Err <> 0 Then
      Print "Error data sending"
    End If
    I2cstop
    If Err <> 0 Then
      Print "Error IC2 Stop"
    End If
Waitms 250

Print "Nunchack Init finished"
Waitms 250
Print "Nunchuck active"

Do
   Gosub Nunchuk_read
   Print Accel_x ; "," ; Accel_y , ; "," ; Accel_z ; "," ; Joy_x ; "," ; Joy_y ; "," ; Buttons.0 ; "," ; Buttons.1
   Leds(1) = Accel_x
   Leds(2) = Accel_y
   Leds(3) = Accel_z
   Leds(4) = Joy_X
   Leds(5) = Joy_Y
   Leds(6) = Buttons And &B01
   Leds(7) = Buttons And &B10

   Waitms 100
Loop

End

Nunchuk_read:
   Dim I As Byte
   Dim Tmp As Byte

   I2cstart
   I2cwbyte Nunchuck_write
   I2cwbyte &H00
    If Err <> 0 Then
      Print "Error data sending"
    End If
   I2cstop

   Waitms 5
   Buffer(1) = 0
   I2creceive Nunchuck_read , Buffer(1) , 0 , 6
   If Err <> 0 Then
     Print "Error data receving"
   End If

   For I = 1 To 6
      Tmp = Buffer(i) Xor &H17
      Tmp = Tmp + &H17
      Buffer(i) = Tmp
   Next I

   Joy_X = Buffer(1)
   Joy_Y = Buffer(2)
   Accel_x = Buffer(3) * 4
   Accel_y = Buffer(4) * 4
   Accel_z = Buffer(5) * 4

   Buttons = Buffer(6)

   If Buttons.2 = 1 Then Accel_x = Accel_x + 1
   If Buttons.3 = 1 Then Accel_x = Accel_x + 2
   If Buttons.4 = 1 Then Accel_y = Accel_y + 1
   If Buttons.5 = 1 Then Accel_y = Accel_y + 2
   If Buttons.6 = 1 Then Accel_z = Accel_z + 1
   If Buttons.7 = 1 Then Accel_z = Accel_z + 2

Return





'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
Portdout = Portdout And 240
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return
End